﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace KdanCommon.CMSCollection.Data
{
    public partial class WindowsCardsResponse
    {
        [JsonProperty("data")]
        public WindowsCardSetting[] Data { get; set; }
    }

    public partial class WindowsCardSetting : ISetting
    {
        public string SettingName
        {
            get
            {
                return Id;
            }
        }

        [JsonProperty("id")]
        public string Id { get; set; }

        [JsonProperty("status")]
        public string Status { get; set; }

        [JsonProperty("sort")]
        public object Sort { get; set; }

        [JsonProperty("user_created")]
        public string UserCreated { get; set; }

        [JsonProperty("date_created")]
        public DateTimeOffset DateCreated { get; set; }

        [JsonProperty("user_updated")]
        public string UserUpdated { get; set; }

        [JsonProperty("date_updated")]
        public DateTimeOffset DateUpdated { get; set; }

        [JsonProperty("Permission")]
        public string Permission { get; set; }

        [JsonProperty("Weight")]
        public long Weight { get; set; }

        [JsonProperty("appTypes")]
        public string[] AppTypes { get; set; }

        [JsonProperty("Start")]
        public DateTimeOffset Start { get; set; }

        [JsonProperty("End")]
        public DateTimeOffset End { get; set; }

        [JsonProperty("include_regions")]
        public bool IncludeRegions { get; set; }

        [JsonProperty("regions")]
        public string[] Regions { get; set; }

        [JsonProperty("Information")]
        public Information[] Information { get; set; }
    }

    public partial class Information
    {
        [JsonProperty("id")]
        public long Id { get; set; }

        [JsonProperty("windows_cards_id")]
        public string WindowsCardsId { get; set; }

        [JsonProperty("languages_code")]
        public string LanguagesCode { get; set; }

        [JsonProperty("Title")]
        public string Title { get; set; }

        [JsonProperty("Description")]
        public string Description { get; set; }

        [JsonProperty("Link")]
        public string Link { get; set; }

        [JsonProperty("Image")]
        public string Image { get; set; }

        public string ImageUrlStr
        {
            get
            {
                if (string.IsNullOrEmpty(Image))
                    return null;
                return $"{CMSCollection.CMSDomain}/assets/{Image}";
            }
        }
    }
}
