﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace KdanCommon.DocAI.Data
{
    public partial class RedactInfoExtractResponse
    {
        [JsonProperty("usage")]
        public Usage Usage { get; set; }

        [JsonProperty("pages")]
        public Page[] Pages { get; set; }

        [JsonProperty("infos")]
        public Info[] Infos { get; set; }
    }


    public partial class Usage
    {
        [JsonProperty("year")]
        public int Year { get; set; }

        [JsonProperty("month")]
        public int Month { get; set; }

        [JsonProperty("pages_used")]
        public int PagesUsed { get; set; }

        [JsonProperty("available_pages")]
        public int AvailablePages { get; set; }
    }

    public partial class Info
    {
        [JsonProperty("type")]
        public string Type { get; set; }

        [JsonProperty("blocks")]
        public Block[] Blocks { get; set; }
    }

    public partial class Block
    {
        [JsonProperty("content")]
        public string Content { get; set; }

        [JsonProperty("extractionContent")]
        public string ExtractionContent { get; set; }

        [JsonProperty("extractionType")]
        public string ExtractionType { get; set; }

        [JsonProperty("boundingRegions")]
        public BoundingRegion[] BoundingRegions { get; set; }
    }

    public partial class BoundingRegion
    {
        [JsonProperty("pageNumber")]
        public int PageNumber { get; set; }

        [JsonProperty("boundingPolygon")]
        public BoundingPolygon[] BoundingPolygon { get; set; }
    }

    public partial class BoundingPolygon
    {
        [JsonProperty("isEmpty")]
        public bool IsEmpty { get; set; }

        [JsonProperty("x")]
        public double X { get; set; }

        [JsonProperty("y")]
        public double Y { get; set; }
    }

    public partial class Page
    {
        [JsonProperty("pageNumber")]
        public int PageNumber { get; set; }

        [JsonProperty("angle")]
        public int Angle { get; set; }

        [JsonProperty("width")]
        public double Width { get; set; }

        [JsonProperty("height")]
        public double Height { get; set; }

        [JsonProperty("unit")]
        public long Unit { get; set; }
    }
}
