﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace KdanCommon.GoogleCloud.Data.Vision
{
    public partial class ImagesResponse
    {
        [JsonProperty("responses")]
        public ImageResponse[] Responses { get; set; }
    }

    public partial class ImageResponse
    {
        [JsonProperty("textAnnotations")]
        public TextAnnotation[] TextAnnotations { get; set; }

        [JsonProperty("fullTextAnnotation")]
        public FullTextAnnotation FullTextAnnotation { get; set; }
    }

    public partial class FullTextAnnotation
    {
        [JsonProperty("pages")]
        public Page[] Pages { get; set; }

        [JsonProperty("text")]
        public string Text { get; set; }
    }

    public partial class Page
    {
        [JsonProperty("property")]
        public WordProperty Property { get; set; }

        [JsonProperty("width")]
        public long Width { get; set; }

        [JsonProperty("height")]
        public long Height { get; set; }

        [JsonProperty("blocks")]
        public Block[] Blocks { get; set; }
    }

    public partial class Block
    {
        [JsonProperty("boundingBox")]
        public Bounding BoundingBox { get; set; }

        [JsonProperty("paragraphs")]
        public Paragraph[] Paragraphs { get; set; }

        [JsonProperty("blockType")]
        public string BlockType { get; set; }
    }

    public partial class Bounding
    {
        [JsonProperty("vertices")]
        public Vertex[] Vertices { get; set; }
    }

    public partial class Vertex
    {
        [JsonProperty("x")]
        public long X { get; set; }

        [JsonProperty("y")]
        public long Y { get; set; }
    }

    public partial class Paragraph
    {
        [JsonProperty("boundingBox")]
        public Bounding BoundingBox { get; set; }

        [JsonProperty("words")]
        public Word[] Words { get; set; }
    }

    public partial class Word
    {
        [JsonProperty("boundingBox")]
        public Bounding BoundingBox { get; set; }

        [JsonProperty("symbols")]
        public Symbol[] Symbols { get; set; }

        [JsonProperty("property", NullValueHandling = NullValueHandling.Ignore)]
        public WordProperty Property { get; set; }
    }

    public partial class WordProperty
    {
        [JsonProperty("detectedLanguages")]
        public DetectedLanguage[] DetectedLanguages { get; set; }
    }

    public partial class DetectedLanguage
    {
        [JsonProperty("languageCode")]
        public string LanguageCode { get; set; }

        [JsonProperty("confidence")]
        public double Confidence { get; set; }
    }

    public partial class Symbol
    {
        [JsonProperty("boundingBox")]
        public Bounding BoundingBox { get; set; }

        [JsonProperty("text")]
        public string Text { get; set; }

        [JsonProperty("property", NullValueHandling = NullValueHandling.Ignore)]
        public SymbolProperty Property { get; set; }
    }

    public partial class SymbolProperty
    {
        [JsonProperty("detectedBreak")]
        public DetectedBreak DetectedBreak { get; set; }
    }

    public partial class DetectedBreak
    {
        [JsonProperty("type")]
        public string Type { get; set; }
    }

    public partial class TextAnnotation
    {
        [JsonProperty("locale", NullValueHandling = NullValueHandling.Ignore)]
        public string Locale { get; set; }

        [JsonProperty("description")]
        public string Description { get; set; }

        [JsonProperty("boundingPoly")]
        public Bounding BoundingPoly { get; set; }
    }
}
